﻿If (-NOT ([Security.Principal.WindowsPrincipal] [Security.Principal.WindowsIdentity]::GetCurrent()).IsInRole([Security.Principal.WindowsBuiltInRole]::Administrator))
{
  # Relaunch as an elevated process:
  Start-Process powershell.exe "-File",('"{0}"' -f $MyInvocation.MyCommand.Path) -Verb RunAs
  exit
}

$igodrivers = Get-WindowsDriver -Online | Where-Object {$_.ProviderName -eq "intelliGo"}
$igopnpswc = Get-PnpDevice | Where-Object {$_.Name -match "intelliGo"}
$igoaudiosvc = Get-Service -DisplayName IgoAudioService -ErrorAction SilentlyContinue
$audiosvc = Get-Service -Name Audiosrv -ErrorAction SilentlyContinue
$audioendpointbuilder = Get-Service -Name audioendpointbuilder -ErrorAction SilentlyContinue
$swserver = Get-Process | Where-Object {$_.Name -match "igoswserver"}

if ($swserver) {
    Stop-Process $($swserver.Id) -Force
}

if ($igoaudiosvc -and $igoaudiosvc.Status -eq "Running") {
    Stop-Service IgoAudioService -Force
}

sc.exe delete "IgoAudioService" | Out-Null
schtasks.exe /delete /tn "\iGoAudioTask" /f

if ($audiosvc -and $audiosvc.Status -eq "Running") {
    Stop-Service -InputObject Audiosrv -Force -ErrorAction SilentlyContinue
}

if ($audioendpointbuilder -and $audioendpointbuilder.Status -eq "Running") {
    Stop-Service -InputObject AudioEndpointBuilder -Force -ErrorAction SilentlyContinue
}

foreach ($swc in $igopnpswc) {
    pnputil /remove-device $($swc.DeviceID)
    Write-Host "$($swc.HardwareID) is removed"
}

foreach ($driver in $igodrivers) {
    pnputil /delete-driver $($driver.Driver) /uninstall | out-null
    Write-Host "$($driver.OriginalFileName) is removed"
}

Start-Service Audiosrv